package de.thpeetz.kontor.admin.views;

import com.vaadin.flow.component.ComponentEvent;
import com.vaadin.flow.component.ComponentEventListener;
import com.vaadin.flow.component.Key;
import com.vaadin.flow.component.button.Button;
import com.vaadin.flow.component.button.ButtonVariant;
import com.vaadin.flow.component.formlayout.FormLayout;
import com.vaadin.flow.component.orderedlayout.HorizontalLayout;
import com.vaadin.flow.component.textfield.TextField;
import com.vaadin.flow.data.binder.BeanValidationBinder;
import com.vaadin.flow.data.binder.Binder;
import de.thpeetz.kontor.admin.data.Permission;
import lombok.extern.slf4j.Slf4j;

@Slf4j
public class PermissionForm extends FormLayout {

    TextField name = new TextField("Role name");

    Button save = new Button("Save");
    Button delete = new Button("Delete");
    Button close = new Button("Cancel");

    Binder<Permission> binder = new BeanValidationBinder<>(Permission.class);

    public PermissionForm() {
        addClassName("permission-form");
        binder.bindInstanceFields(this);
        add(name, createButtonsLayout());
    }

    private HorizontalLayout createButtonsLayout() {
        save.addThemeVariants(ButtonVariant.LUMO_PRIMARY);
        delete.addThemeVariants(ButtonVariant.LUMO_ERROR);
        close.addThemeVariants(ButtonVariant.LUMO_TERTIARY);

        save.addClickShortcut(Key.ENTER);
        close.addClickShortcut(Key.ESCAPE);

        save.addClickListener(event -> validateAndSave());
        delete.addClickListener(event -> fireEvent(new DeleteEvent(this, binder.getBean())));
        close.addClickListener(event -> fireEvent(new CloseEvent(this)));

        binder.addStatusChangeListener(e -> save.setEnabled(binder.isValid()));
        return new HorizontalLayout(save, delete, close);
    }

    private void validateAndSave() {
        if (binder.isValid()) {
            fireEvent(new SaveEvent(this, binder.getBean()));
        }
    }

    public void setPermission(Permission permission) {
        binder.setBean(permission);
    }

    public abstract static class PermissionFormEvent extends ComponentEvent<PermissionForm> {
        private Permission permission;

        protected PermissionFormEvent(PermissionForm source, Permission permission) {
            super(source, false);
            this.permission = permission;
        }

        public Permission getPermission() {
            return permission;
        }
    }

    public static class SaveEvent extends PermissionFormEvent {
        SaveEvent(PermissionForm source, Permission permission) {
            super(source, permission);
        }
    }

    public static class DeleteEvent extends PermissionFormEvent {
        DeleteEvent(PermissionForm source, Permission permission) {
            super(source, permission);
        }
    }

    public static class CloseEvent extends PermissionFormEvent {
        CloseEvent(PermissionForm source) {
            super(source, null);
        }
    }

    public void addDeleteListener(ComponentEventListener<DeleteEvent> listener) {
        addListener(DeleteEvent.class, listener);
    }

    public void addSaveListener(ComponentEventListener<SaveEvent> listener) {
        addListener(SaveEvent.class, listener);
    }

    public void addCloseListener(ComponentEventListener<CloseEvent> listener) {
        addListener(CloseEvent.class, listener);
    }
}
